diff --git a/.gitlab-ci.yml b/.gitlab-ci.yml
index 8472604..428c5db 100644
--- a/.gitlab-ci.yml
+++ b/.gitlab-ci.yml
@@ -16,36 +16,49 @@ default:
 Install Dependencies:
   stage: install_deps
   cache:
-    key:
-      files:
-        - yarn.lock
-    paths:
-      - node_modules
-    policy: pull-push
+    - key:
+        files:
+          - yarn.lock
+      paths:
+        - node_modules
+      policy: pull-push
+    - key: yarn-$CI_JOB_IMAGE
+      paths:
+        - .yarn
+      policy: pull-push
   script:
-    - yarn install
+    - yarn install --cache-folder .yarn
 
 Test:
   stage: test
   cache:
-    key:
-      files:
-        - yarn.lock
-    paths:
-      - node_modules
-    policy: pull
+    - key:
+        files:
+          - yarn.lock
+      paths:
+        - node_modules
+      policy: pull
+    - key: test-$CI_JOB_IMAGE
+      paths:
+        - .jestcache
+      policy: pull-push
   script:
-    - yarn test
+    - yarn test --cacheDirectory ".jestcache"
 
 Build:
   stage: build
   cache:
-    key:
-      files:
-        - yarn.lock
-    paths:
-      - node_modules
-    policy: pull
+    - key:
+        files:
+          - yarn.lock
+      paths:
+        - node_modules
+      policy: pull
+    - key: build-$CI_JOB_IMAGE
+      paths:
+        - .cache
+        - public
+      policy: pull-push
   script:
     - yarn build
   artifacts:
